| OpendTect 8.0

Loading...
Searching...
No Matches
Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
MPE::Horizon2DExtenderBase Class Reference
MPEEngine

Sub class of SectionExtender for 2D Horizons with its factory. More...

`#include <horizon2dextender.h>`

Inheritance diagram for MPE::Horizon2DExtenderBase:
[legend]

## Public Member Functions
| ~Horizon2DExtenderBase ()
Pos::GeomID | geomID () const
float | getAngleThreshold () const
const TrcKeyValue * | getDirection () const override
int | nextStep () override
void | setAngleThreshold (float radians)
void | setDirection (const TrcKeyValue &) override
void | setGeomID (const Pos::GeomID &)
Public Member Functions inherited from MPE::SectionExtender
virtual | ~SectionExtender ()
const char * | errMsg () const
void | excludePositions (const TypeSet< TrcKey > *)
void | extendInVolume (const BinID &bidstep, float zstep)
virtual void | fillPar (IOPar &) const
const TypeSet< TrcKey > & | getAddedPositions () const
const TypeSet< TrcKey > & | getAddedPositionsSource () const
virtual const TrcKeyZSampling & | getExtBoundary () const
bool | isExcludedPos (const TrcKey &) const
virtual int | maxNrPosInExtArea () const
int | nextStep () override
virtual void | preallocExtArea ()
virtual void | reset ()
mDeprecatedObs EM::SectionID | sectionID () const
void | setExtBoundary (const TrcKeyZSampling &)
void | setStartPosition (const TrcKey &)
void | setStartPositions (const TypeSet< TrcKey > &)
void | setUndo (bool yn)
void | unsetExtBoundary ()
virtual bool | usePar (const IOPar &)
Public Member Functions inherited from SequentialTask
| SequentialTask (const char *nm=nullptr)
virtual | ~SequentialTask ()
virtual int | doStep ()
bool | execute () override
Public Member Functions inherited from ReportingTask
| ReportingTask (const ReportingTask &)=delete
virtual | ~ReportingTask ()
void | getProgress (const ReportingTask &)
ReportingTask & | operator= (const ReportingTask &)=delete
void | setSimpleMeter (bool yn, int repperc)
int | simpleMeterStep () const
bool | useSimpleMeter () const
Public Member Functions inherited from Task
| Task (const Task &)=delete
virtual | ~Task ()
virtual void | controlWork (Control)
virtual void | enableWorkControl (bool=true)
| Must be called before execute()
virtual uiRetVal | errorWithDetails () const
virtual Control | getState () const
virtual od_int64 | nrDone () const
Task & | operator= (const Task &)=delete
virtual od_int64 | totalNr () const
virtual uiString | uiMessage () const
virtual uiString | uiNrDoneText () const
bool | workControlEnabled () const
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const

## Static Public Member Functions
static Horizon2DExtenderBase * | createInstance (EM::Horizon2D &)
Static Public Member Functions inherited from SequentialTask
static int | ErrorOccurred ()
static int | Finished ()
static int | MoreToDo ()
static int | WarningAvailable ()
Static Public Member Functions inherited from ReportingTask
static PtrMan< ProgressMeter > | getTextProgressMeter (od_ostream &, const IOPar *iop=nullptr)
static bool | needSimpleLogging (const IOPar &)
static const char * | sKeySimpleLogging ()
static const char * | sKeySimpleLoggingStep ()
Static Public Member Functions inherited from Task
static uiString | uiStdNrDoneText ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()

## Protected Member Functions
| Horizon2DExtenderBase (EM::Horizon2D &)
void | addNeighbor (bool upwards, const TrcKey &sourcesid)
float | getDepth (const TrcKey &src, const TrcKey &target) const override
void | prepareDataIfRequired () override
Protected Member Functions inherited from MPE::SectionExtender
| SectionExtender ()
void | addTarget (const TrcKey &target, const TrcKey &src)
Protected Member Functions inherited from SequentialTask
virtual bool | doFinish (bool success, od_ostream *=nullptr)
virtual bool | doPrepare (od_ostream *=nullptr)
Protected Member Functions inherited from ReportingTask
| ReportingTask (const char *nm=nullptr)
void | incrementProgress ()
ProgressMeter * | progressMeter () const
void | reportProgressFinished ()
void | reportProgressStarted ()
void | resetProgress ()
void | setProgressMeter (ProgressMeter *) override
| Must be called before execute()
void | updateProgressMeter (bool forced=false, od_int64 *totalnr=0)
void | updateReportedName ()
Protected Member Functions inherited from Task
| Task (const char *nm=nullptr)
virtual bool | shouldContinue ()
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const

## Protected Attributes
bool | alldirs_ = true
float | anglethreshold_ = 0.5f
TrcKeyValue | direction_
Pos::GeomID | geomid_
EM::Horizon2D & | hor2d_
Coord | xydirection_
Protected Attributes inherited from MPE::SectionExtender
TypeSet< TrcKey > | addedpos_
TypeSet< TrcKey > | addedpossrc_
BufferString | errmsg
const TypeSet< TrcKey > * | excludedpos_ = nullptr
TrcKeyZSampling | extboundary_
bool | setundo_ = true
TypeSet< TrcKey > | startpos_
Protected Attributes inherited from Task
Control | control_ = Task::Run
Threads::ConditionVar * | workcontrolcondvar_ = nullptr
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Additional Inherited Members
Public Types inherited from Task
enum | Control { Run , Pause , Stop }
Public Types inherited from ObjectWithName
typedef OD::String | name_type
Public Attributes inherited from ReportingTask
Notifier< ReportingTask > | progressUpdated

## Detailed Description

Sub class of SectionExtender for 2D Horizons with its factory.

<>

## Constructor & Destructor Documentation

## ◆ ~Horizon2DExtenderBase()

MPE::Horizon2DExtenderBase::~Horizon2DExtenderBase | ( |  | ) |

## ◆ Horizon2DExtenderBase()

MPE::Horizon2DExtenderBase::Horizon2DExtenderBase | ( | EM::Horizon2D & |  | ) |
| protected

## Member Function Documentation

## ◆ addNeighbor()

void MPE::Horizon2DExtenderBase::addNeighbor | ( | bool | upwards,
|  | const TrcKey & | sourcesid )
| protected

## ◆ createInstance()

static Horizon2DExtenderBase * MPE::Horizon2DExtenderBase::createInstance | ( | EM::Horizon2D & |  | ) |
| static

## ◆ geomID()

Pos::GeomID MPE::Horizon2DExtenderBase::geomID | ( |  | ) | const

## ◆ getAngleThreshold()

float MPE::Horizon2DExtenderBase::getAngleThreshold | ( |  | ) | const

## ◆ getDepth()

float MPE::Horizon2DExtenderBase::getDepth | ( | const TrcKey & | src,
|  | const TrcKey & | target ) const
| override protected virtual

Reimplemented from MPE::SectionExtender.

## ◆ getDirection()

const TrcKeyValue * MPE::Horizon2DExtenderBase::getDirection | ( |  | ) | const
| override virtual

Reimplemented from MPE::SectionExtender.

## ◆ nextStep()

int MPE::Horizon2DExtenderBase::nextStep | ( |  | ) |
| override virtual

Return values

  MoreToDo() | Not finished. Call me again.
  Finished() | Nothing more to do.
  ErrorOccurred() | Something went wrong.

Note
  if function returns a value greater than cMoreToDo(), it should be interpreted as cMoreToDo().

Implements SequentialTask.

## ◆ prepareDataIfRequired()

void MPE::Horizon2DExtenderBase::prepareDataIfRequired | ( |  | ) |
| inline override protected virtual

Reimplemented from MPE::SectionExtender.

## ◆ setAngleThreshold()

void MPE::Horizon2DExtenderBase::setAngleThreshold | ( | float | radians | ) |

## ◆ setDirection()

void MPE::Horizon2DExtenderBase::setDirection | ( | const TrcKeyValue & |  | ) |
| override virtual

Reimplemented from MPE::SectionExtender.

## ◆ setGeomID()

void MPE::Horizon2DExtenderBase::setGeomID | ( | const Pos::GeomID & |  | ) |

## Member Data Documentation

## ◆ alldirs_

bool MPE::Horizon2DExtenderBase::alldirs_ = true
| protected

## ◆ anglethreshold_

float MPE::Horizon2DExtenderBase::anglethreshold_ = 0.5f
| protected

## ◆ direction_

TrcKeyValue MPE::Horizon2DExtenderBase::direction_
| protected

## ◆ geomid_

Pos::GeomID MPE::Horizon2DExtenderBase::geomid_
| protected

## ◆ hor2d_

EM::Horizon2D& MPE::Horizon2DExtenderBase::hor2d_
| protected

## ◆ xydirection_

Coord MPE::Horizon2DExtenderBase::xydirection_
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025